/**
 * スマートフォンでの通話やLINE風のアプリの振る舞いを模倣するプログラム
 * 
 * @author kaiya
 * 
 */
public class Ex2 {

	/**
	 * 動作テストのサンプルプログラム TODO 適当に改造して結構です．
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		// 四台のスマートフォンを作成 引数は電話番号
		SmartPhone murata = new SmartPhone(314);
		SmartPhone yamada = new SmartPhone(128);
		SmartPhone saeki = new SmartPhone(256);
		SmartPhone tanaka = new SmartPhone(414);

		// murataさんは他全員をアドレス帳にいれる
		murata.addAddress(yamada);
		murata.addAddress(saeki);
		murata.addAddress(tanaka);
		// yamadaさんはアドレス帳が空
		// saekiさんはtanakaさんのみ入っている
		saeki.addAddress(tanaka);
		// tanakaさんはyamadaさんのみ入っている
		tanaka.addAddress(yamada);

		// この時点では全て空のはず
		checkFreeCallAddresses(murata, yamada, saeki, tanaka);

		// アプリLを実行可能としている人たち
		murata.activateLine();
		saeki.activateLine();

		// 多少増えてるはず
		checkFreeCallAddresses(murata, yamada, saeki, tanaka);

		// 適当に通話する
		Call c = murata.call(saeki); // 無料
		if (c != null)
			c.hangUp();
		c = yamada.call(tanaka); // 有料
		if (c != null)
			c.hangUp();
		// 面倒だから，通話の例は適当に追加して，つながらない例も入っていると面白いかも．

		// それぞれ通話料金を表示
		for (Callable call : new Callable[] { murata, yamada, saeki, tanaka }) {
			System.out.printf("%d -> JPY %d\n", call.getNumber(),
					call.getTotalCharge()); // JPYは日本円の略称
		}

	}

	/**
	 * それぞれの無料通話可能な相手を列挙してみる．
	 * 
	 * @param sp
	 *            チェックする電話のリスト
	 */
	private static void checkFreeCallAddresses(SmartPhone... sp) {
		for (SmartPhone s : sp) {
			System.out.println(s.getNumber() + ": ");
			for (Callable c : s.getFreeAddresses()) {
				System.out.println(c.getNumber() + " ");
			}
			System.out.println();
		}

	}

}
